## xrootd-s3-http 0.5.3

=== CMakeLists.txt ===
cmake_minimum_required( VERSION 3.14 )

project( xrootd-http/s3 )

option( XROOTD_PLUGINS_EXTERNAL_GTEST "Use an external/pre-installed copy of GTest" OFF )
option( VALGRIND "Run select unit tests under valgrind" OFF )
option( ENABLE_ASAN "Build the plugin with the address sanitizer" OFF )

set( CMAKE_MODULE_PATH ${PROJECT_SOURCE_DIR}/cmake )
if( "${CMAKE_BUILD_TYPE}" STREQUAL "" )
  set( CMAKE_BUILD_TYPE Debug )
endif()

find_package( XRootD REQUIRED COMPONENTS UTILS SERVER )
find_package( CURL REQUIRED )
find_package( Threads REQUIRED )
find_package( OpenSSL REQUIRED )

if(VALGRIND)
  find_program(VALGRIND_BIN valgrind REQUIRED)
endif()

if( ENABLE_ASAN )
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fsanitize=address")
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fsanitize=address")
  set(CMAKE_LINKER_FLAGS "${CMAKE_LINKER_FLAGS} -fsanitize=address")
endif()

set( CMAKE_CXX_STANDARD 17 )
set( CMAKE_CXX_STANDARD_REQUIRED ON )

if( CMAKE_BUILD_TYPE STREQUAL Debug )
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -Werror" )
endif()

if(NOT APPLE)
  SET( CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -Wl,--no-undefined")
  SET( CMAKE_MODULE_LINKER_FLAGS "${CMAKE_MODULE_LINKER_FLAGS} -Wl,--no-undefined")
endif()

# Our custom Filesystem module creates the std::filesystem library target for
# any special dependencies needed for using std::filesystem.
find_package( Filesystem REQUIRED )
# Similar setup for libatomic; required only on 32-bit systems
find_package( Atomic REQUIRED )

# Add nlohmann/json dependency (use system if available; otherwise, fetch it)
find_package(nlohmann_json 3.11.2 QUIET)
if(NOT nlohmann_json_FOUND)
  include(FetchContent)
  # Allow a locally-found tarball; if missing, fall back to upstream URL
  set(JSON_URL "${CMAKE_CURRENT_SOURCE_DIR}/nlohmann-json-3.11.2.tar.xz")
  if(NOT EXISTS "${JSON_URL}")
    set(JSON_URL "https://github.com/nlohmann/json/releases/download/v3.11.2/json.tar.xz")
  endif()
  cmake_policy(SET CMP0135 NEW)
  FetchContent_Declare(
    nlohmann_json
    URL "${JSON_URL}"
    URL_HASH SHA256=8c4b26bf4b422252e13f332bc5e388ec0ab5c3443d24399acb675e68278d341f
  )
  FetchContent_MakeAvailable(nlohmann_json)
endif()

if( NOT XROOTD_EXTERNAL_TINYXML2 )
  include(FetchContent)
  # Allow a locally-found tinyxml2 tarball to be used; provides the ability for packagers
  # to build this without any external network connectivity (as in the case of Koji).
  set( TINYXML2_URL "${CMAKE_CURRENT_SOURCE_DIR}/tinyxml2-10.0.0.tar.gz" )
  if( NOT EXISTS "${TINYXML2_URL}" )
    set( TINYXML2_URL "https://github.com/leethomason/tinyxml2/archive/refs/tags/10.0.0.tar.gz" )
  endif()
  cmake_policy( SET CMP0135 NEW )
  FetchContent_Declare(
    tinyxml2
    URL "${TINYXML2_URL}"
    URL_HASH SHA256=3bdf15128ba16686e69bce256cc468e76c7b94ff2c7f391cc5ec09e40bff3839
    )
  set(CMAKE_POSITION_INDEPENDENT_CODE ON CACHE INTERNAL "Force tinyxml2 to use PIC")
  FetchContent_MakeAvailable( tinyxml2 )
else()
  find_package( tinyxml2 REQUIRED )
endif()

##
# Flag is needed explicitly for 32-bit platforms but not currently exported by XRootD
# as a reverse dependency.  Can be removed once this is merged and in all supported
# releases:
#
# https://github.com/xrootd/xrootd/pull/2369
#
add_definitions( -D_FILE_OFFSET_BITS=64 )

######################
##  libXrdOssS3     ##
######################
# On Linux, we hide all the symbols for the final libraries, exposing only what's needed for the XRootD
# runtime loader.  So here we create the object library and will create a separate one for testing with
# the symbols exposed.
add_library(XrdS3Obj OBJECT src/CurlUtil.cc src/S3File.cc src/S3Directory.cc src/S3AccessInfo.cc src/S3FileSystem.cc src/AWSv4-impl.cc src/S3Commands.cc src/HTTPCommands.cc src/TokenFile.cc src/stl_string_utils.cc src/shortfile.cc src/logging.cc)
set_target_properties(XrdS3Obj PROPERTIES POSITION_INDEPENDENT_CODE ON)
target_include_directories(XrdS3Obj PRIVATE ${XRootD_INCLUDE_DIRS})
target_link_libraries( XrdS3Obj ${XRootD_UTILS_LIBRARIES} ${XRootD_SERVER_LIBRARIES} CURL::libcurl OpenSSL::Crypto tinyxml2::tinyxml2 Threads::Threads std::filesystem std::atomic )

# Compatability library, doesn't match upstream's naming convention
add_library(XrdS3 MODULE "$<TARGET_OBJECTS:XrdS3Obj>")
target_link_libraries(XrdS3 XrdS3Obj)
# New library name, matches upstream's naming convention
add_library(XrdOssS3 MODULE "$<TARGET_OBJECTS:XrdS3Obj>")
target_link_libraries(XrdOssS3 XrdS3Obj)

######################
##  libXrdOssHTTP   ##
######################
add_library(XrdHTTPServerObj OBJECT src/CurlUtil.cc src/HTTPFile.cc src/HTTPDirectory.cc src/HTTPFileSystem.cc src/HTTPCommands.cc src/TokenFile.cc src/stl_string_utils.cc src/shortfile.cc src/logging.cc)
set_target_properties(XrdHTTPServerObj PROPERTIES POSITION_INDEPENDENT_CODE ON)
target_include_directories(XrdHTTPServerObj PRIVATE ${XRootD_INCLUDE_DIRS})
target_link_libraries(XrdHTTPServerObj ${XRootD_UTILS_LIBRARIES} ${XRootD_SERVER_LIBRARIES} CURL::libcurl  tinyxml2::tinyxml2 OpenSSL::Crypto Threads::Threads std::filesystem)

# Compatability library, doesn't match upstream's naming convention
add_library(XrdHTTPServer MODULE "$<TARGET_OBJECTS:XrdHTTPServerObj>")
target_link_libraries(XrdHTTPServer XrdHTTPServerObj)
# New library name, matches upstream's naming convention
add_library(XrdOssHttp MODULE "$<TARGET_OBJECTS:XrdHTTPServerObj>")
target_link_libraries(XrdOssHttp XrdHTTPServerObj)

######################
## libXrdOssFilter  ##
######################
add_library( XrdOssFilterObj OBJECT src/Filter.cc src/logging.cc )
set_target_properties( XrdOssFilterObj PROPERTIES POSITION_INDEPENDENT_CODE ON )
target_include_directories( XrdOssFilterObj PRIVATE ${XRootD_INCLUDE_DIRS} )
target_link_libraries( XrdOssFilterObj ${XRootD_UTILS_LIBRARIES} ${XRootD_SERVER_LIBRARIES} )

add_library( XrdOssFilter MODULE "$<TARGET_OBJECTS:XrdOssFilterObj>" )
target_link_libraries( XrdOssFilter XrdOssFilterObj )

######################
## libXrdOssGlobus  ##
######################
add_library(XrdOssGlobusObj OBJECT src/HTTPCommands.cc src/GlobusFile.cc src/GlobusFileSystem.cc src/GlobusDirectory.cc src/logging.cc src/stl_string_utils.cc src/shortfile.cc src/TokenFile.cc src/CurlUtil.cc)
set_target_properties(XrdOssGlobusObj PROPERTIES POSITION_INDEPENDENT_CODE ON)
target_include_directories(XrdOssGlobusObj PRIVATE ${XRootD_INCLUDE_DIRS})
target_link_libraries(XrdOssGlobusObj ${XRootD_UTILS_LIBRARIES} ${XRootD_SERVER_LIBRARIES} nlohmann_json::nlohmann_json CURL::libcurl OpenSSL::Crypto Threads::Threads std::filesystem)

add_library(XrdOssGlobus MODULE "$<TARGET_OBJECTS:XrdOssGlobusObj>")
target_link_libraries(XrdOssGlobus XrdOssGlobusObj)

#######################
## libXrdOssPosc     ##
#######################
add_library( XrdOssPoscObj OBJECT src/Posc.cc )
set_target_properties( XrdOssPoscObj PROPERTIES POSITION_INDEPENDENT_CODE ON )
target_link_libraries( XrdOssPoscObj XRootD::XrdServer XRootD::XrdUtils Threads::Threads std::atomic )

add_library( XrdOssPosc MODULE "$<TARGET_OBJECTS:XrdOssPoscObj>" )
target_link_libraries( XrdOssPosc XrdOssPoscObj )

# Customize module's suffix and, on Linux, hide unnecessary symbols
if( APPLE )
  set_target_properties( XrdS3 PROPERTIES OUTPUT_NAME "XrdS3-${XRootD_PLUGIN_VERSION}" SUFFIX ".so" )
  set_target_properties( XrdHTTPServer PROPERTIES OUTPUT_NAME "XrdHTTPServer-${XRootD_PLUGIN_VERSION}" SUFFIX ".so" )
  set_target_properties( XrdOssS3 PROPERTIES OUTPUT_NAME "XrdOssS3-${XRootD_PLUGIN_VERSION}" SUFFIX ".so" )
  set_target_properties( XrdOssHttp PROPERTIES OUTPUT_NAME "XrdOssHttp-${XRootD_PLUGIN_VERSION}" SUFFIX ".so" )
  set_target_properties( XrdOssFilter PROPERTIES OUTPUT_NAME "XrdOssFilter-${XRootD_PLUGIN_VERSION}" SUFFIX ".so" )
  set_target_properties( XrdOssGlobus PROPERTIES OUTPUT_NAME "XrdOssGlobus-${XRootD_PLUGIN_VERSION}" SUFFIX ".so" )
  set_target_properties( XrdOssPosc PROPERTIES OUTPUT_NAME "XrdOssPosc-${XRootD_PLUGIN_VERSION}" SUFFIX ".so" )
else()
  set_target_properties( XrdS3 PROPERTIES OUTPUT_NAME "XrdS3-${XRootD_PLUGIN_VERSION}" SUFFIX ".so" LINK_FLAGS "-Wl,--version-script=${CMAKE_SOURCE_DIR}/configs/export-lib-symbols" )
  set_target_properties( XrdHTTPServer PROPERTIES OUTPUT_NAME "XrdHTTPServer-${XRootD_PLUGIN_VERSION}" SUFFIX ".so" LINK_FLAGS "-Wl,--version-script=${CMAKE_SOURCE_DIR}/configs/export-lib-symbols" )
  set_target_properties( XrdOssS3 PROPERTIES OUTPUT_NAME "XrdOssS3-${XRootD_PLUGIN_VERSION}" SUFFIX ".so" LINK_FLAGS "-Wl,--version-script=${CMAKE_SOURCE_DIR}/configs/export-lib-symbols" )
  set_target_properties( XrdOssHttp PROPERTIES OUTPUT_NAME "XrdOssHttp-${XRootD_PLUGIN_VERSION}" SUFFIX ".so" LINK_FLAGS "-Wl,--version-script=${CMAKE_SOURCE_DIR}/configs/export-lib-symbols" )
  set_target_properties( XrdOssFilter PROPERTIES OUTPUT_NAME "XrdOssFilter-${XRootD_PLUGIN_VERSION}" SUFFIX ".so" LINK_FLAGS "-Wl,--version-script=${CMAKE_SOURCE_DIR}/configs/export-lib-symbols" )
  set_target_properties( XrdOssGlobus PROPERTIES OUTPUT_NAME "XrdOssGlobus-${XRootD_PLUGIN_VERSION}" SUFFIX ".so" LINK_FLAGS "-Wl,--version-script=${CMAKE_SOURCE_DIR}/configs/export-lib-symbols" )
  set_target_properties( XrdOssPosc PROPERTIES OUTPUT_NAME "XrdOssPosc-${XRootD_PLUGIN_VERSION}" SUFFIX ".so" LINK_FLAGS "-Wl,--version-script=${CMAKE_SOURCE_DIR}/configs/export-lib-symbols" )
endif()

include(GNUInstallDirs)

install(
  TARGETS XrdS3 XrdHTTPServer XrdOssS3 XrdOssHttp XrdOssFilter XrdOssGlobus XrdOssPosc
  LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
)

if( ENABLE_TESTS )
  # Create shared libraries for testing from the existing objects
  add_library(XrdS3Testing SHARED "$<TARGET_OBJECTS:XrdS3Obj>")
  target_link_libraries(XrdS3Testing XrdS3Obj)
  target_include_directories(XrdS3Testing INTERFACE ${XRootD_INCLUDE_DIRS})

  add_library(XrdHTTPServerTesting SHARED "$<TARGET_OBJECTS:XrdHTTPServerObj>")
  target_link_libraries(XrdHTTPServerTesting XrdHTTPServerObj)
  target_include_directories(XrdHTTPServerTesting INTERFACE ${XRootD_INCLUDE_DIRS})

  add_library( XrdOssFilterTesting SHARED "$<TARGET_OBJECTS:XrdOssFilterObj>" )
  target_link_libraries( XrdOssFilterTesting XrdOssFilterObj )
  target_include_directories( XrdOssFilterTesting INTERFACE ${XRootD_INCLUDE_DIRS} )

  add_library(XrdOssGlobusTesting SHARED "$<TARGET_OBJECTS:XrdOssGlobusObj>")
  target_link_libraries(XrdOssGlobusTesting XrdOssGlobusObj)
  target_include_directories(XrdOssGlobusTesting INTERFACE ${XRootD_INCLUDE_DIRS})

  add_library( XrdOssPoscTesting SHARED "$<TARGET_OBJECTS:XrdOssPoscObj>" )
  target_link_libraries( XrdOssPoscTesting XrdOssPoscObj )
  target_include_directories( XrdOssPoscTesting INTERFACE ${XRootD_INCLUDE_DIRS} )

  find_program(GoWrk go-wrk HINTS "$ENV{HOME}/go/bin")
  if( NOT GoWrk )
    # Try installing the go-wrk variable to generate a reasonable stress test
    execute_process( COMMAND go install github.com/bbockelm/go-wrk@92dbe19
      RESULT_VARIABLE go_install_result )
    if( go_install_result EQUAL 0 )
      find_program(GoWrk go-wrk HINTS "$ENV{HOME}/go/bin")
    else()
      message( WARNING "Failed to install the go-wrk binary" )
    endif()
  endif()

  if( NOT XROOTD_PLUGINS_EXTERNAL_GTEST )
    include( FetchContent )
    set( GTEST_URL "${CMAKE_CURRENT_SOURCE_DIR}/googletest-1.15.2.tar.gz" )
    if( NOT EXISTS "${GTEST_URL}" )
        set( GTEST_URL "https://github.com/google/googletest/releases/download/v1.15.2/googletest-1.15.2.tar.gz" )
    endif()
    cmake_policy(SET CMP0135 NEW)
    FetchContent_Declare(GTest
      URL "${GTEST_URL}"
      URL_HASH SHA256=7b42b4d6ed48810c5362c265a17faebe90dc2373c885e5216439d37927f02926
      TEST_COMMAND ""
    )
    FetchContent_MakeAvailable( GTest )
  else()
    find_package(GTest REQUIRED)
  endif()

  enable_testing()
  add_subdirectory(test)
endif()

=== test/CMakeLists.txt ===
set(EXECUTABLES "minio" "mc")

foreach(EXE IN LISTS EXECUTABLES)

  find_program(EXE_BIN ${EXE} HINTS "${CMAKE_CURRENT_BINARY_DIR}")

  if(NOT EXE_BIN)
    message("Didnt find ${EXE}. Downloading it ...")

    if (APPLE)
      set(SYS_NAME "darwin")
    else()
      set(SYS_NAME "linux")
    endif()

    if(CMAKE_SYSTEM_PROCESSOR STREQUAL "arm64" OR
       CMAKE_SYSTEM_PROCESSOR STREQUAL "aarch64")
      set(SYS_PROC "arm64")
    else()
      set(SYS_PROC "amd64")
    endif()

    if (EXE STREQUAL "minio")
      set(DIR "server")
    else()
      set(DIR "client")
    endif()

    set(URL "https://dl.min.io/${DIR}/${EXE}/release/${SYS_NAME}-${SYS_PROC}/${EXE}")
    set(FILE "${CMAKE_CURRENT_BINARY_DIR}/${EXE}")
    message("Downloading ${URL} to ${FILE}")
    file(DOWNLOAD "${URL}" "${FILE}" STATUS download_status)

    list(GET download_status 0 RESULT_CODE)
    if (RESULT_CODE EQUAL 0)
      file(CHMOD "${FILE}" PERMISSIONS
             OWNER_READ OWNER_WRITE OWNER_EXECUTE
             GROUP_READ GROUP_EXECUTE
             WORLD_READ WORLD_EXECUTE)
    else()
      file(REMOVE "${FILE}")
      message(WARNING "Failed to download ${EXE}: ${RESULT_CODE}")
    endif()

  endif()

endforeach()

find_program(MINIO_BIN minio HINTS "${CMAKE_CURRENT_BINARY_DIR}")
find_program(MC_BIN mc       HINTS "${CMAKE_CURRENT_BINARY_DIR}")
if (NOT MINIO_BIN OR NOT MC_BIN)
  message(WARNING "minio and/or mc are missing, will skip many s3 tests")
endif()

include(GoogleTest)

add_executable( s3-gtest s3_tests.cc )
add_executable( s3-unit-test s3_unit_tests.cc )
add_executable( http-gtest http_tests.cc )
add_executable( filter-gtest filter_tests.cc ../src/shortfile.cc )
add_executable( posc-gtest posc_tests.cc ../src/shortfile.cc )

target_link_libraries(s3-gtest XrdS3Testing GTest::gtest_main Threads::Threads)
target_link_libraries(s3-unit-test XrdS3Testing GTest::gtest_main Threads::Threads)
target_link_libraries(http-gtest XrdHTTPServerTesting GTest::gtest_main Threads::Threads)
target_link_libraries(filter-gtest XrdOssFilterTesting GTest::gtest_main Threads::Threads)
target_link_libraries(posc-gtest XrdOssPoscTesting GTest::gtest_main Threads::Threads)

gtest_add_tests(TARGET filter-gtest TEST_LIST filterUnitTests)

set_tests_properties(${filterUnitTests}
  PROPERTIES
    ENVIRONMENT "LSAN_OPTIONS=suppressions=${CMAKE_CURRENT_SOURCE_DIR}/lsan-suppressions.txt"
)

if (MINIO_BIN AND MC_BIN)
  gtest_add_tests(TARGET s3-unit-test TEST_LIST s3UnitTests)
  set_tests_properties(${s3UnitTests}
    PROPERTIES
      FIXTURES_REQUIRED S3::s3_basic
      ENVIRONMENT "ENV_FILE=${CMAKE_BINARY_DIR}/tests/s3_basic/setup.sh;LSAN_OPTIONS=suppressions=${CMAKE_CURRENT_SOURCE_DIR}/lsan-suppressions.txt"
  )
endif()

gtest_add_tests(TARGET posc-gtest TEST_LIST poscUnitTests)

set_tests_properties(${poscUnitTests}
  PROPERTIES
    ENVIRONMENT "LSAN_OPTIONS=suppressions=${CMAKE_CURRENT_SOURCE_DIR}/lsan-suppressions.txt"
)

add_test(
  NAME
    s3-unit
  COMMAND
    ${CMAKE_CURRENT_BINARY_DIR}/s3-gtest
)
set_tests_properties(s3-unit
  PROPERTIES
    ENVIRONMENT "LSAN_OPTIONS=suppressions=${CMAKE_CURRENT_SOURCE_DIR}/lsan-suppressions.txt"
)

gtest_add_tests(TARGET http-gtest TEST_LIST httpUnitTests)

set_tests_properties( ${httpUnitTests}
  PROPERTIES
    ENVIRONMENT "ENV_FILE=${CMAKE_CURRENT_BINARY_DIR}/../tests/basic/setup.sh;LSAN_OPTIONS=suppressions=${CMAKE_CURRENT_SOURCE_DIR}/lsan-suppressions.txt"
    FIXTURES_REQUIRED HTTP::basic
)

if (VALGRIND)
  add_test(
    NAME
      valgrind-s3
    COMMAND
      ${VALGRIND_BIN} ${CMAKE_CURRENT_BINARY_DIR}/s3-unit-test -R FileSystemS3Fixture.UploadLargePartAligned
  )

  set_tests_properties(valgrind-s3
    PROPERTIES
      FIXTURES_REQUIRED S3::s3_basic
  )
endif()

######################################
# Integration tests.
######################################
add_test(NAME HTTP::basic::setup
  COMMAND "${CMAKE_CURRENT_SOURCE_DIR}/xrdhttp-setup.sh" basic)

set_tests_properties(HTTP::basic::setup
  PROPERTIES
    FIXTURES_SETUP HTTP::basic
    ENVIRONMENT "BINARY_DIR=${CMAKE_BINARY_DIR};SOURCE_DIR=${CMAKE_SOURCE_DIR};XROOTD_BINDIR=${XRootD_DATA_DIR}/../bin;LD_LIBRARY_PATH=${XRootD_LIB_DIR}"
)

add_test(NAME HTTP::basic::teardown
  COMMAND "${CMAKE_CURRENT_SOURCE_DIR}/xrdhttp-teardown.sh" basic)

set_tests_properties(HTTP::basic::teardown
  PROPERTIES
    FIXTURES_CLEANUP HTTP::basic
    ENVIRONMENT "BINARY_DIR=${CMAKE_BINARY_DIR}"
)

add_test(NAME HTTP::basic::test
  COMMAND "${CMAKE_CURRENT_SOURCE_DIR}/xrdhttp-test.sh" basic)

list(APPEND BASIC_TEST_LOGS ${CMAKE_CURRENT_BINARY_DIR}/tests/basic/server.log)
list(APPEND BASIC_TEST_LOGS ${CMAKE_CURRENT_BINARY_DIR}/tests/basic/client.log)

set_tests_properties(HTTP::basic::test
  PROPERTIES
    FIXTURES_REQUIRED HTTP::basic
    ENVIRONMENT "BINARY_DIR=${CMAKE_BINARY_DIR}"
    ATTACHED_FILES_ON_FAIL "${BASIC_TEST_LOGS}"
)

####
#   Start of S3 tests, which require minio and mc
####
if (MINIO_BIN AND MC_BIN)
  add_test(NAME S3::s3_basic::setup
    COMMAND "${CMAKE_CURRENT_SOURCE_DIR}/s3-setup.sh" s3_basic)

  set_tests_properties(S3::s3_basic::setup
    PROPERTIES
      FIXTURES_SETUP S3::s3_basic
      ENVIRONMENT "BINARY_DIR=${CMAKE_BINARY_DIR};SOURCE_DIR=${CMAKE_CURRENT_SOURCE_DIR};XROOTD_BINDIR=${XRootD_DATA_DIR}/../bin;LD_LIBRARY_PATH=${XRootD_LIB_DIR};MINIO_BIN=${MINIO_BIN};MC_BIN=${MC_BIN}"
  )

  add_test(NAME S3::s3_basic::teardown
    COMMAND "${CMAKE_CURRENT_SOURCE_DIR}/s3-teardown.sh" s3_basic)

  set_tests_properties(S3::s3_basic::teardown
    PROPERTIES
      FIXTURES_CLEANUP S3::s3_basic
      ENVIRONMENT "BINARY_DIR=${CMAKE_BINARY_DIR}"
  )

  add_test(NAME S3::s3_basic::test
    COMMAND "${CMAKE_CURRENT_SOURCE_DIR}/s3-test.sh" s3_basic)

  add_test(NAME S3::s3_basic::stress_test
    COMMAND "${CMAKE_CURRENT_SOURCE_DIR}/s3-stress-test.sh" s3_basic)

  list(APPEND S3_BASIC_TEST_LOGS ${CMAKE_CURRENT_BINARY_DIR}/tests/s3_basic/server.log)
  list(APPEND S3_BASIC_TEST_LOGS ${CMAKE_CURRENT_BINARY_DIR}/tests/s3_basic/client.log)

  set_tests_properties(S3::s3_basic::test
    PROPERTIES
      FIXTURES_REQUIRED S3::s3_basic
      ENVIRONMENT "BINARY_DIR=${CMAKE_BINARY_DIR}"
      ATTACHED_FILES_ON_FAIL "${S3_BASIC_TEST_LOGS}"
  )

  set_tests_properties(S3::s3_basic::stress_test
    PROPERTIES
      FIXTURES_REQUIRED S3::s3_basic
      ENVIRONMENT "BINARY_DIR=${CMAKE_BINARY_DIR}"
      ATTACHED_FILES_ON_FAIL "${S3_BASIC_TEST_LOGS}"
  )

  #######################################
  # Stress-test using the go-wrk binary #
  #######################################

  if( GoWrk )
  add_test( NAME S3::s3_basic::gowrk_test
    COMMAND "${CMAKE_CURRENT_SOURCE_DIR}/s3-gowrk-test.sh" s3_basic )

  set_tests_properties( S3::s3_basic::gowrk_test
    PROPERTIES
      FIXTURES_REQUIRED S3::s3_basic
      ENVIRONMENT "BINARY_DIR=${CMAKE_BINARY_DIR};WRK_BIN=${GoWrk}"
      ATTACHED_FILES_ON_FAIL "${S3_BASIC_TEST_LOGS}"
  )
  endif()

endif()

=== debian/changelog ===
xrootd-s3-http (0.5.3-1) unstable; urgency=medium

  * Update to version 0.5.3

 -- Mattias Ellert <mattias.ellert@physics.uu.se>  Wed, 29 Oct 2025 09:26:27 +0100

=== debian/control ===
Source: xrootd-s3-http
Section: net
Priority: optional
Standards-Version: 4.7.2
Build-Depends:
 debhelper-compat (= 13),
 cmake,
 pkgconf,
 nlohmann-json3-dev,
 libxrootd-server-dev,
 libcurl4-openssl-dev,
 libssl-dev,
 libtinyxml2-dev,
 libgtest-dev,
 curl,
 openssl,
 procps,
 xrootd-server
Homepage: https://github.com/PelicanPlatform/xrootd-s3-http
Maintainer: Mattias Ellert <mattias.ellert@physics.uu.se>
Vcs-Browser: https://salsa.debian.org/ellert/xrootd-s3-http
Vcs-Git: https://salsa.debian.org/ellert/xrootd-s3-http.git

Package: xrootd-s3-http
Architecture: any
Multi-Arch: same
Section: libs
Depends:
 xrootd-server,
 ${shlibs:Depends},
 ${misc:Depends}
Description: S3/HTTP filesystem plugins for XRootD
 These filesystem plugins for XRootD allow you to serve objects from S3
 and HTTP backends through an XRootD server.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

export DEB_BUILD_MAINT_OPTIONS = hardening=+bindnow

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- \
		-DXROOTD_EXTERNAL_TINYXML2:BOOL=ON \
		-DXROOTD_PLUGINS_EXTERNAL_GTEST:BOOL=ON \
		-DENABLE_TESTS:BOOL=ON \
		-DEXE_BIN:PATH=/bin/true

override_dh_auto_test:
	# s3 tests require network (https://s3.us-east-1.amazonaws.com)
	# posc tests fail when run in parallel:
	# https://github.com/PelicanPlatform/xrootd-s3-http/issues/111
	dh_auto_test -- ARGS+="-E 'S3|s3|TestPosc'"

override_dh_auto_install:
	dh_auto_install --destdir=debian/tmp

## xrootd-s3-http 0.6.0

=== debian/changelog ===
xrootd-s3-http (0.6.0-1) unstable; urgency=medium

  * Update to version 0.6.0

 -- Mattias Ellert <mattias.ellert@physics.uu.se>  Mon, 12 Jan 2026 15:30:19 +0100

## xrootd-s3-http 0.6.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -91,38 +91,51 @@
 #
 add_definitions( -D_FILE_OFFSET_BITS=64 )
 
+set(PelicanHttpCoreSources
+  src/CurlUtil.cc
+  src/HTTPCommands.cc
+  src/TokenFile.cc
+  src/stl_string_utils.cc
+  src/shortfile.cc
+  src/logging.cc)
+
+add_library(XrdPelicanHttpCore SHARED ${PelicanHttpCoreSources})
+set_target_properties(XrdPelicanHttpCore PROPERTIES POSITION_INDEPENDENT_CODE ON)
+target_include_directories(XrdPelicanHttpCore PRIVATE ${XRootD_INCLUDE_DIRS})
+target_link_libraries(XrdPelicanHttpCore ${XRootD_UTILS_LIBRARIES} ${XRootD_SERVER_LIBRARIES} CURL::libcurl OpenSSL::Crypto tinyxml2::tinyxml2 Threads::Threads std::filesystem std::atomic)
+
 ######################
 ##  libXrdOssS3     ##
 ######################
 # On Linux, we hide all the symbols for the final libraries, exposing only what's needed for the XRootD
 # runtime loader.  So here we create the object library and will create a separate one for testing with
 # the symbols exposed.
-add_library(XrdS3Obj OBJECT src/CurlUtil.cc src/S3File.cc src/S3Directory.cc src/S3AccessInfo.cc src/S3FileSystem.cc src/AWSv4-impl.cc src/S3Commands.cc src/HTTPCommands.cc src/TokenFile.cc src/stl_string_utils.cc src/shortfile.cc src/logging.cc)
+add_library(XrdS3Obj OBJECT src/S3File.cc src/S3Directory.cc src/S3AccessInfo.cc src/S3FileSystem.cc src/AWSv4-impl.cc src/S3Commands.cc)
 set_target_properties(XrdS3Obj PROPERTIES POSITION_INDEPENDENT_CODE ON)
 target_include_directories(XrdS3Obj PRIVATE ${XRootD_INCLUDE_DIRS})
 target_link_libraries( XrdS3Obj ${XRootD_UTILS_LIBRARIES} ${XRootD_SERVER_LIBRARIES} CURL::libcurl OpenSSL::Crypto tinyxml2::tinyxml2 Threads::Threads std::filesystem std::atomic )
 
 # Compatability library, doesn't match upstream's naming convention
 add_library(XrdS3 MODULE "$<TARGET_OBJECTS:XrdS3Obj>")
-target_link_libraries(XrdS3 XrdS3Obj)
+target_link_libraries(XrdS3 XrdS3Obj XrdPelicanHttpCore)
 # New library name, matches upstream's naming convention
 add_library(XrdOssS3 MODULE "$<TARGET_OBJECTS:XrdS3Obj>")
-target_link_libraries(XrdOssS3 XrdS3Obj)
+target_link_libraries(XrdOssS3 XrdS3Obj XrdPelicanHttpCore)
 
 ######################
 ##  libXrdOssHTTP   ##
 ######################
-add_library(XrdHTTPServerObj OBJECT src/CurlUtil.cc src/HTTPFile.cc src/HTTPDirectory.cc src/HTTPFileSystem.cc src/HTTPCommands.cc src/TokenFile.cc src/stl_string_utils.cc src/shortfile.cc src/logging.cc)
+add_library(XrdHTTPServerObj OBJECT src/HTTPFile.cc src/HTTPDirectory.cc src/HTTPFileSystem.cc)
 set_target_properties(XrdHTTPServerObj PROPERTIES POSITION_INDEPENDENT_CODE ON)
 target_include_directories(XrdHTTPServerObj PRIVATE ${XRootD_INCLUDE_DIRS})
 target_link_libraries(XrdHTTPServerObj ${XRootD_UTILS_LIBRARIES} ${XRootD_SERVER_LIBRARIES} CURL::libcurl  tinyxml2::tinyxml2 OpenSSL::Crypto Threads::Threads std::filesystem)
 
 # Compatability library, doesn't match upstream's naming convention
 add_library(XrdHTTPServer MODULE "$<TARGET_OBJECTS:XrdHTTPServerObj>")
-target_link_libraries(XrdHTTPServer XrdHTTPServerObj)
+target_link_libraries(XrdHTTPServer XrdHTTPServerObj XrdPelicanHttpCore)
 # New library name, matches upstream's naming convention
 add_library(XrdOssHttp MODULE "$<TARGET_OBJECTS:XrdHTTPServerObj>")
-target_link_libraries(XrdOssHttp XrdHTTPServerObj)
+target_link_libraries(XrdOssHttp XrdHTTPServerObj XrdPelicanHttpCore)
 
 ######################
 ## libXrdOssFilter  ##
@@ -138,13 +151,13 @@
 ######################
 ## libXrdOssGlobus  ##
 ######################
-add_library(XrdOssGlobusObj OBJECT src/HTTPCommands.cc src/GlobusFile.cc src/GlobusFileSystem.cc src/GlobusDirectory.cc src/logging.cc src/stl_string_utils.cc src/shortfile.cc src/TokenFile.cc src/CurlUtil.cc)
+add_library(XrdOssGlobusObj OBJECT src/GlobusFile.cc src/GlobusFileSystem.cc src/GlobusDirectory.cc)
 set_target_properties(XrdOssGlobusObj PROPERTIES POSITION_INDEPENDENT_CODE ON)
 target_include_directories(XrdOssGlobusObj PRIVATE ${XRootD_INCLUDE_DIRS})
 target_link_libraries(XrdOssGlobusObj ${XRootD_UTILS_LIBRARIES} ${XRootD_SERVER_LIBRARIES} nlohmann_json::nlohmann_json CURL::libcurl OpenSSL::Crypto Threads::Threads std::filesystem)
 
 add_library(XrdOssGlobus MODULE "$<TARGET_OBJECTS:XrdOssGlobusObj>")
-target_link_libraries(XrdOssGlobus XrdOssGlobusObj)
+target_link_libraries(XrdOssGlobus XrdOssGlobusObj XrdPelicanHttpCore)
 
 #######################
 ## libXrdOssPosc     ##
@@ -156,8 +169,20 @@
 add_library( XrdOssPosc MODULE "$<TARGET_OBJECTS:XrdOssPoscObj>" )
 target_link_libraries( XrdOssPosc XrdOssPoscObj )
 
+#######################
+## libXrdN2NPrefix   ##
+#######################
+add_library( XrdN2NPrefixObj OBJECT src/PrefixN2N.cc )
+set_target_properties( XrdN2NPrefixObj PROPERTIES POSITION_INDEPENDENT_CODE ON )
+target_include_directories( XrdN2NPrefixObj PRIVATE ${XRootD_INCLUDE_DIRS} )
+target_link_libraries( XrdN2NPrefixObj ${XRootD_UTILS_LIBRARIES} ${XRootD_SERVER_LIBRARIES} nlohmann_json::nlohmann_json )
+
+add_library( XrdN2NPrefix MODULE "$<TARGET_OBJECTS:XrdN2NPrefixObj>" )
+target_link_libraries( XrdN2NPrefix XrdN2NPrefixObj )
+
 # Customize module's suffix and, on Linux, hide unnecessary symbols
 if( APPLE )
+  set_target_properties( XrdPelicanHttpCore PROPERTIES OUTPUT_NAME "XrdPelicanHttpCore-${XRootD_PLUGIN_VERSION}" SUFFIX ".so" )
   set_target_properties( XrdS3 PROPERTIES OUTPUT_NAME "XrdS3-${XRootD_PLUGIN_VERSION}" SUFFIX ".so" )
   set_target_properties( XrdHTTPServer PROPERTIES OUTPUT_NAME "XrdHTTPServer-${XRootD_PLUGIN_VERSION}" SUFFIX ".so" )
   set_target_properties( XrdOssS3 PROPERTIES OUTPUT_NAME "XrdOssS3-${XRootD_PLUGIN_VERSION}" SUFFIX ".so" )
@@ -165,7 +190,9 @@
   set_target_properties( XrdOssFilter PROPERTIES OUTPUT_NAME "XrdOssFilter-${XRootD_PLUGIN_VERSION}" SUFFIX ".so" )
   set_target_properties( XrdOssGlobus PROPERTIES OUTPUT_NAME "XrdOssGlobus-${XRootD_PLUGIN_VERSION}" SUFFIX ".so" )
   set_target_properties( XrdOssPosc PROPERTIES OUTPUT_NAME "XrdOssPosc-${XRootD_PLUGIN_VERSION}" SUFFIX ".so" )
+  set_target_properties( XrdN2NPrefix PROPERTIES OUTPUT_NAME "XrdN2NPrefix-${XRootD_PLUGIN_VERSION}" SUFFIX ".so" )
 else()
+  set_target_properties( XrdPelicanHttpCore PROPERTIES OUTPUT_NAME "XrdPelicanHttpCore-${XRootD_PLUGIN_VERSION}" SUFFIX ".so" )
   set_target_properties( XrdS3 PROPERTIES OUTPUT_NAME "XrdS3-${XRootD_PLUGIN_VERSION}" SUFFIX ".so" LINK_FLAGS "-Wl,--version-script=${CMAKE_SOURCE_DIR}/configs/export-lib-symbols" )
   set_target_properties( XrdHTTPServer PROPERTIES OUTPUT_NAME "XrdHTTPServer-${XRootD_PLUGIN_VERSION}" SUFFIX ".so" LINK_FLAGS "-Wl,--version-script=${CMAKE_SOURCE_DIR}/configs/export-lib-symbols" )
   set_target_properties( XrdOssS3 PROPERTIES OUTPUT_NAME "XrdOssS3-${XRootD_PLUGIN_VERSION}" SUFFIX ".so" LINK_FLAGS "-Wl,--version-script=${CMAKE_SOURCE_DIR}/configs/export-lib-symbols" )
@@ -173,66 +200,28 @@
   set_target_properties( XrdOssFilter PROPERTIES OUTPUT_NAME "XrdOssFilter-${XRootD_PLUGIN_VERSION}" SUFFIX ".so" LINK_FLAGS "-Wl,--version-script=${CMAKE_SOURCE_DIR}/configs/export-lib-symbols" )
   set_target_properties( XrdOssGlobus PROPERTIES OUTPUT_NAME "XrdOssGlobus-${XRootD_PLUGIN_VERSION}" SUFFIX ".so" LINK_FLAGS "-Wl,--version-script=${CMAKE_SOURCE_DIR}/configs/export-lib-symbols" )
   set_target_properties( XrdOssPosc PROPERTIES OUTPUT_NAME "XrdOssPosc-${XRootD_PLUGIN_VERSION}" SUFFIX ".so" LINK_FLAGS "-Wl,--version-script=${CMAKE_SOURCE_DIR}/configs/export-lib-symbols" )
+  set_target_properties( XrdN2NPrefix PROPERTIES OUTPUT_NAME "XrdN2NPrefix-${XRootD_PLUGIN_VERSION}" SUFFIX ".so" LINK_FLAGS "-Wl,--version-script=${CMAKE_SOURCE_DIR}/configs/export-lib-symbols" )
+  #set_target_properties( XrdOfsRedirect PROPERTIES OUTPUT_NAME "XrdOfsRedirect-${XRootD_PLUGIN_VERSION}" SUFFIX ".so" LINK_FLAGS "-Wl,--version-script=${CMAKE_SOURCE_DIR}/configs/export-ofs-lib-symbols" )
 endif()
 
 include(GNUInstallDirs)
 
 install(
-  TARGETS XrdS3 XrdHTTPServer XrdOssS3 XrdOssHttp XrdOssFilter XrdOssGlobus XrdOssPosc
+  TARGETS XrdPelicanHttpCore XrdS3 XrdHTTPServer XrdOssS3 XrdOssHttp XrdOssFilter XrdOssGlobus XrdOssPosc XrdN2NPrefix
   LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
 )
 
 if( ENABLE_TESTS )
   # Create shared libraries for testing from the existing objects
   add_library(XrdS3Testing SHARED "$<TARGET_OBJECTS:XrdS3Obj>")
-  target_link_libraries(XrdS3Testing XrdS3Obj)
+  target_link_libraries(XrdS3Testing XrdS3Obj XrdPelicanHttpCore)
   target_include_directories(XrdS3Testing INTERFACE ${XRootD_INCLUDE_DIRS})
 
   add_library(XrdHTTPServerTesting SHARED "$<TARGET_OBJECTS:XrdHTTPServerObj>")
-  target_link_libraries(XrdHTTPServerTesting XrdHTTPServerObj)
+  target_link_libraries(XrdHTTPServerTesting XrdHTTPServerObj XrdPelicanHttpCore)
   target_include_directories(XrdHTTPServerTesting INTERFACE ${XRootD_INCLUDE_DIRS})
 
   add_library( XrdOssFilterTesting SHARED "$<TARGET_OBJECTS:XrdOssFilterObj>" )
   target_link_libraries( XrdOssFilterTesting XrdOssFilterObj )
   target_include_directories( XrdOssFilterTesting INTERFACE ${XRootD_INCLUDE_DIRS} )
 
-  add_library(XrdOssGlobusTesting SHARED "$<TARGET_OBJECTS:XrdOssGlobusObj>")
-  target_link_libraries(XrdOssGlobusTesting XrdOssGlobusObj)
-  target_include_directories(XrdOssGlobusTesting INTERFACE ${XRootD_INCLUDE_DIRS})
-
-  add_library( XrdOssPoscTesting SHARED "$<TARGET_OBJECTS:XrdOssPoscObj>" )
-  target_link_libraries( XrdOssPoscTesting XrdOssPoscObj )
-  target_include_directories( XrdOssPoscTesting INTERFACE ${XRootD_INCLUDE_DIRS} )
-
-  find_program(GoWrk go-wrk HINTS "$ENV{HOME}/go/bin")
-  if( NOT GoWrk )
-    # Try installing the go-wrk variable to generate a reasonable stress test
-    execute_process( COMMAND go install github.com/bbockelm/go-wrk@92dbe19
-      RESULT_VARIABLE go_install_result )
-    if( go_install_result EQUAL 0 )
-      find_program(GoWrk go-wrk HINTS "$ENV{HOME}/go/bin")
-    else()
-      message( WARNING "Failed to install the go-wrk binary" )
-    endif()
-  endif()
-
-  if( NOT XROOTD_PLUGINS_EXTERNAL_GTEST )
-    include( FetchContent )
-    set( GTEST_URL "${CMAKE_CURRENT_SOURCE_DIR}/googletest-1.15.2.tar.gz" )
-    if( NOT EXISTS "${GTEST_URL}" )
-        set( GTEST_URL "https://github.com/google/googletest/releases/download/v1.15.2/googletest-1.15.2.tar.gz" )
-    endif()
-    cmake_policy(SET CMP0135 NEW)
-    FetchContent_Declare(GTest
-      URL "${GTEST_URL}"
-      URL_HASH SHA256=7b42b4d6ed48810c5362c265a17faebe90dc2373c885e5216439d37927f02926
-      TEST_COMMAND ""
-    )
-    FetchContent_MakeAvailable( GTest )
-  else()
-    find_package(GTest REQUIRED)
-  endif()
-
-  enable_testing()
-  add_subdirectory(test)
-endif()

=== test/CMakeLists.txt ===
--- 
+++ 
@@ -59,16 +59,25 @@
 add_executable( http-gtest http_tests.cc )
 add_executable( filter-gtest filter_tests.cc ../src/shortfile.cc )
 add_executable( posc-gtest posc_tests.cc ../src/shortfile.cc )
+add_executable( n2n-prefix-gtest n2n_prefix_tests.cc ../src/shortfile.cc )
 
 target_link_libraries(s3-gtest XrdS3Testing GTest::gtest_main Threads::Threads)
 target_link_libraries(s3-unit-test XrdS3Testing GTest::gtest_main Threads::Threads)
 target_link_libraries(http-gtest XrdHTTPServerTesting GTest::gtest_main Threads::Threads)
 target_link_libraries(filter-gtest XrdOssFilterTesting GTest::gtest_main Threads::Threads)
 target_link_libraries(posc-gtest XrdOssPoscTesting GTest::gtest_main Threads::Threads)
+target_link_libraries(n2n-prefix-gtest XrdN2NPrefixTesting GTest::gtest_main Threads::Threads)
 
 gtest_add_tests(TARGET filter-gtest TEST_LIST filterUnitTests)
 
 set_tests_properties(${filterUnitTests}
+  PROPERTIES
+    ENVIRONMENT "LSAN_OPTIONS=suppressions=${CMAKE_CURRENT_SOURCE_DIR}/lsan-suppressions.txt"
+)
+
+gtest_add_tests(TARGET n2n-prefix-gtest TEST_LIST n2nPrefixUnitTests)
+
+set_tests_properties(${n2nPrefixUnitTests}
   PROPERTIES
     ENVIRONMENT "LSAN_OPTIONS=suppressions=${CMAKE_CURRENT_SOURCE_DIR}/lsan-suppressions.txt"
 )
@@ -156,6 +165,40 @@
     ATTACHED_FILES_ON_FAIL "${BASIC_TEST_LOGS}"
 )
 
+######################################
+# N2N (Name-to-Name) Integration Tests
+######################################
+add_test(NAME N2N::basic::setup
+  COMMAND "${CMAKE_CURRENT_SOURCE_DIR}/n2n-setup.sh" n2n_basic)
+
+set_tests_properties(N2N::basic::setup
+  PROPERTIES
+    FIXTURES_SETUP N2N::basic
+    ENVIRONMENT "BINARY_DIR=${CMAKE_BINARY_DIR};SOURCE_DIR=${CMAKE_SOURCE_DIR};XROOTD_BINDIR=${XRootD_DATA_DIR}/../bin;LD_LIBRARY_PATH=${XRootD_LIB_DIR}:${CMAKE_BINARY_DIR}/lib"
+)
+
+add_test(NAME N2N::basic::teardown
+  COMMAND "${CMAKE_CURRENT_SOURCE_DIR}/n2n-teardown.sh" n2n_basic)
+
+set_tests_properties(N2N::basic::teardown
+  PROPERTIES
+    FIXTURES_CLEANUP N2N::basic
+    ENVIRONMENT "BINARY_DIR=${CMAKE_BINARY_DIR}"
+)
+
+add_test(NAME N2N::basic::test
+  COMMAND "${CMAKE_CURRENT_SOURCE_DIR}/n2n-test.sh" n2n_basic)
+
+list(APPEND N2N_BASIC_TEST_LOGS ${CMAKE_BINARY_DIR}/tests/n2n_basic/server.log)
+list(APPEND N2N_BASIC_TEST_LOGS ${CMAKE_BINARY_DIR}/tests/n2n_basic/client.log)
+
+set_tests_properties(N2N::basic::test
+  PROPERTIES
+    FIXTURES_REQUIRED N2N::basic
+    ENVIRONMENT "BINARY_DIR=${CMAKE_BINARY_DIR}"
+    ATTACHED_FILES_ON_FAIL "${N2N_BASIC_TEST_LOGS}"
+)
+
 ####
 #   Start of S3 tests, which require minio and mc
 ####

=== debian/changelog ===
xrootd-s3-http (0.6.1-1) unstable; urgency=medium

  * Update to version 0.6.1

 -- Mattias Ellert <mattias.ellert@physics.uu.se>  Tue, 20 Jan 2026 16:52:29 +0100

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,6 @@
 Source: xrootd-s3-http
 Section: net
-Priority: optional
-Standards-Version: 4.7.2
+Standards-Version: 4.7.3
 Build-Depends:
  debhelper-compat (= 13),
  cmake,
@@ -29,6 +28,6 @@
  xrootd-server,
  ${shlibs:Depends},
  ${misc:Depends}
-Description: S3/HTTP filesystem plugins for XRootD
+Description: S3/HTTP/Globus filesystem plugins for XRootD
  These filesystem plugins for XRootD allow you to serve objects from S3
  and HTTP backends through an XRootD server.

## xrootd-s3-http 0.6.3

=== debian/changelog ===
xrootd-s3-http (0.6.3-1) unstable; urgency=medium

  * Update to version 0.6.3
  * Drop patches - accepted upstream

 -- Mattias Ellert <mattias.ellert@physics.uu.se>  Wed, 28 Jan 2026 12:55:11 +0100

## xrootd-s3-http 0.6.4

=== CMakeLists.txt ===
--- 
+++ 
@@ -100,6 +100,7 @@
   src/logging.cc)
 
 add_library(XrdPelicanHttpCore SHARED ${PelicanHttpCoreSources})
+set_target_properties(XrdPelicanHttpCore PROPERTIES VERSION 0.0.0 SOVERSION 0)
 set_target_properties(XrdPelicanHttpCore PROPERTIES POSITION_INDEPENDENT_CODE ON)
 target_include_directories(XrdPelicanHttpCore PRIVATE ${XRootD_INCLUDE_DIRS})
 target_link_libraries(XrdPelicanHttpCore ${XRootD_UTILS_LIBRARIES} ${XRootD_SERVER_LIBRARIES} CURL::libcurl OpenSSL::Crypto tinyxml2::tinyxml2 Threads::Threads std::filesystem std::atomic)
@@ -182,7 +183,6 @@
 
 # Customize module's suffix and, on Linux, hide unnecessary symbols
 if( APPLE )
-  set_target_properties( XrdPelicanHttpCore PROPERTIES OUTPUT_NAME "XrdPelicanHttpCore-${XRootD_PLUGIN_VERSION}" SUFFIX ".so" )
   set_target_properties( XrdS3 PROPERTIES OUTPUT_NAME "XrdS3-${XRootD_PLUGIN_VERSION}" SUFFIX ".so" )
   set_target_properties( XrdHTTPServer PROPERTIES OUTPUT_NAME "XrdHTTPServer-${XRootD_PLUGIN_VERSION}" SUFFIX ".so" )
   set_target_properties( XrdOssS3 PROPERTIES OUTPUT_NAME "XrdOssS3-${XRootD_PLUGIN_VERSION}" SUFFIX ".so" )
@@ -192,7 +192,6 @@
   set_target_properties( XrdOssPosc PROPERTIES OUTPUT_NAME "XrdOssPosc-${XRootD_PLUGIN_VERSION}" SUFFIX ".so" )
   set_target_properties( XrdN2NPrefix PROPERTIES OUTPUT_NAME "XrdN2NPrefix-${XRootD_PLUGIN_VERSION}" SUFFIX ".so" )
 else()
-  set_target_properties( XrdPelicanHttpCore PROPERTIES OUTPUT_NAME "XrdPelicanHttpCore-${XRootD_PLUGIN_VERSION}" SUFFIX ".so" )
   set_target_properties( XrdS3 PROPERTIES OUTPUT_NAME "XrdS3-${XRootD_PLUGIN_VERSION}" SUFFIX ".so" LINK_FLAGS "-Wl,--version-script=${CMAKE_SOURCE_DIR}/configs/export-lib-symbols" )
   set_target_properties( XrdHTTPServer PROPERTIES OUTPUT_NAME "XrdHTTPServer-${XRootD_PLUGIN_VERSION}" SUFFIX ".so" LINK_FLAGS "-Wl,--version-script=${CMAKE_SOURCE_DIR}/configs/export-lib-symbols" )
   set_target_properties( XrdOssS3 PROPERTIES OUTPUT_NAME "XrdOssS3-${XRootD_PLUGIN_VERSION}" SUFFIX ".so" LINK_FLAGS "-Wl,--version-script=${CMAKE_SOURCE_DIR}/configs/export-lib-symbols" )
@@ -225,3 +224,5 @@
   target_link_libraries( XrdOssFilterTesting XrdOssFilterObj )
   target_include_directories( XrdOssFilterTesting INTERFACE ${XRootD_INCLUDE_DIRS} )
 
+  add_library(XrdOssGlobusTesting SHARED "$<TARGET_OBJECTS:XrdOssGlobusObj>")
+  target_link_libraries(XrdOssGlobusTesting XrdOssGlobusObj XrdPelicanHttpCore)

=== debian/changelog ===
xrootd-s3-http (0.6.4-1) unstable; urgency=medium

  * Update to version 0.6.4

 -- Mattias Ellert <mattias.ellert@physics.uu.se>  Tue, 10 Feb 2026 17:00:01 +0100

=== debian/rules ===
--- 
+++ 
@@ -15,9 +15,8 @@
 
 override_dh_auto_test:
 	# s3 tests require network (https://s3.us-east-1.amazonaws.com)
-	# posc tests fail when run in parallel:
-	# https://github.com/PelicanPlatform/xrootd-s3-http/issues/111
-	dh_auto_test -- ARGS+="-E 'S3|s3|TestPosc'"
+	dh_auto_test -- ARGS+="-E 'S3|s3'"
 
 override_dh_auto_install:
 	dh_auto_install --destdir=debian/tmp
+	rm debian/tmp/usr/lib/*/libXrdPelicanHttpCore.so
